"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProcessingOrderFrom = exports.MergeStatus = exports.DocumentVisitTraversal = exports.HDocCommandType = void 0;

/**
 * Lists all the fields of all the types that are mapped in the
 * maps interface passed as parameter
 */

/**
 * Lists all the types that are mapped in the Maps interface T.
 */

/**
 * A lazy mutable delta represents the differences between the map the
 * lazy mutable map was initialized with and the change operations that have
 * subsequently been performed on it.
 */

/**
 * Wraps a Javascript map, creating lazily a new shallow copy if
 * we perform changes on it.
 *
 * It allows using the object as a mutable map and return a new copy
 * only if any changes happened withing some potentially mutating code.
 *
 * The typical use is withing non-trivial reducers, where changes may
 * happen after a number of different conditions, and where we don't want
 * to create a new map if we don't need to nor keep checking if we need a new
 * version of the original map.
 */

/**
 * Each element in the path that from the root of the document
 * brings us to an element
 */

/**
 * The type of Path elements we can find within a normalized entity is more
 * constrained.
 */

/**
 * A path identifies uniquely an element within the hierarchical
 * document, or the fields withing an element.
 */

/**
 * A normalized document represents a tree like document made
 * up of linked entities.
 *
 * Entities refer to each other via Ids, and there is a root element
 * pointed to by element type and id.
 *
 * All the data in the document is captured via maps of Id, entities,
 * one map for each data type.
 */
let HDocCommandType;
exports.HDocCommandType = HDocCommandType;

(function (HDocCommandType) {
  HDocCommandType["INSERT_ELEMENT"] = "InsertElementChange";
  HDocCommandType["CHANGE_ELEMENT"] = "ChangeElementChange";
  HDocCommandType["DELETE_ELEMENT"] = "DeleteElementChange";
  HDocCommandType["MOVE_ELEMENT"] = "MoveElementChange";
})(HDocCommandType || (exports.HDocCommandType = HDocCommandType = {}));

let DocumentVisitTraversal;
/**
 * The status of merging two versions of a value, element
 * or element position
 */

exports.DocumentVisitTraversal = DocumentVisitTraversal;

(function (DocumentVisitTraversal) {
  DocumentVisitTraversal["BREADTH_FIRST"] = "breadth_first";
  DocumentVisitTraversal["DEPTH_FIRST"] = "depth_first";
})(DocumentVisitTraversal || (exports.DocumentVisitTraversal = DocumentVisitTraversal = {}));

let MergeStatus;
/**
 * A conflicted value represents a field value of an element
 * which can have one of a number of values, generated on
 * different versions of the same document.
 */

exports.MergeStatus = MergeStatus;

(function (MergeStatus) {
  MergeStatus["open"] = "open";
  MergeStatus["autoMerged"] = "autoMerged";
  MergeStatus["resolved"] = "resolved";
})(MergeStatus || (exports.MergeStatus = MergeStatus = {}));

let ProcessingOrderFrom;
exports.ProcessingOrderFrom = ProcessingOrderFrom;

(function (ProcessingOrderFrom) {
  ProcessingOrderFrom[ProcessingOrderFrom["both"] = 0] = "both";
  ProcessingOrderFrom[ProcessingOrderFrom["left"] = 1] = "left";
  ProcessingOrderFrom[ProcessingOrderFrom["right"] = 2] = "right";
})(ProcessingOrderFrom || (exports.ProcessingOrderFrom = ProcessingOrderFrom = {}));
//# sourceMappingURL=HTypes.js.map