import { DocumentVisitTraversal, Id, INormalizedDocument, INormalizedMutableMapsDocument, IVisitor } from './HTypes';
/**
 * Traversal of a normalized document, calling
 * for each node the visitor function passed as parameter.
 *
 * The traversal is breadth first by default, unless the
 * goBreadthFirst parameter is false in which case its depthFirst
 *
 * @param {IDocumentSchema<MapsInterface, V>} docSchema
 * @param {INormalizedDocument<MapsInterface, U, V>} doc
 * @param {IVisitor<MapsInterface, U, V>} onNodeVisit
 * @param {Context} context
 */
export declare function visitDocument<MapsInterface, U extends keyof MapsInterface = keyof MapsInterface, Context extends any = any>(doc: INormalizedDocument<MapsInterface, U> | INormalizedMutableMapsDocument<MapsInterface, U>, onNodeVisit: IVisitor<MapsInterface, U>, context?: Context, traversal?: DocumentVisitTraversal, elementType?: U, elementId?: Id): void;
