import { ILazyMutableMap, ILazyMutableMapDelta } from './HTypes';
export declare class LazyMutableMap<K, V> implements ILazyMutableMap<K, V> {
    protected readonly originalValuesMap: Map<K, V>;
    protected valuesMap: Map<K, V>;
    protected added: Map<K, V>;
    protected changed: Map<K, V>;
    protected deleted: Set<K>;
    constructor(originalMap: Map<K, V>);
    hasChanged: () => boolean;
    set: (key: K, value: V) => LazyMutableMap<K, V>;
    get: (key: K) => undefined | V;
    has: (key: K) => boolean;
    delete: (key: K) => boolean;
    getMap: () => Map<K, V>;
    keys: () => IterableIterator<K>;
    values: () => IterableIterator<V>;
    protected createCopyIfNeeded: () => void;
    getOriginal: (key: K) => undefined | V;
    delta: () => ILazyMutableMapDelta<K, V>;
}
